--- gcc-4.0.0.orig/ChangeLog	21 Apr 2005 05:17:11 -0000	1.1057.2.10
+++ gcc-4.0.0/ChangeLog	25 Apr 2005 10:36:54 -0000	1.1057.2.11
@@ -1,3 +1,8 @@
+2005-04-25  Bernd Schmidt  <bernd.schmidt@analog.com>
+
+	* MAINTAINERS: Add self as Blackfin maintainer
+	* config.sub: Import from master version.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/MAINTAINERS	14 Apr 2005 22:56:33 -0000	1.399.2.5
+++ gcc-4.0.0/MAINTAINERS	25 Apr 2005 10:36:20 -0000	1.399.2.6
@@ -42,6 +42,7 @@
 arm port		Paul Brook		paul@codesourcery.com
 avr port		Denis Chertykov		denisc@overta.ru
 avr port		Marek Michalkiewicz	marekm@amelek.gda.pl
+bfin port		Bernd Schmidt		bernd.schmidt@analog.com
 c4x port		Michael Hayes		m.hayes@elec.canterbury.ac.nz
 cris port		Hans-Peter Nilsson	hp@axis.com
 fr30 port		Nick Clifton		nickc@redhat.com
--- gcc-4.0.0.orig/configure.in	21 Apr 2005 02:45:11 -0000	1.341.2.2
+++ gcc-4.0.0/configure.in	2 May 2005 04:35:43 -0000
@@ -413,7 +413,7 @@
     noconfigdirs="$noconfigdirs target-newlib target-libiberty target-libgloss ${libgcj} target-libmudflap"
     ;;
   *-*-rtems*)
-    noconfigdirs="$noconfigdirs target-libgloss ${libgcj}"
+    noconfigdirs="$noconfigdirs target-libgloss target-libiberty ${libgcj}"
     ;;
   *-*-uclinux*)
     noconfigdirs="$noconfigdirs target-newlib target-libgloss target-rda ${libgcj}"
--- gcc-4.0.0.orig/boehm-gc/configure.ac	16 Feb 2005 04:10:41 -0000	1.12
+++ gcc-4.0.0/boehm-gc/configure.ac	2 May 2005 04:35:53 -0000
@@ -186,6 +186,10 @@
 	;;
     esac
     ;;
+ rtems)
+    AC_DEFINE(GC_RTEMS_THREADS,1)
+    THREADLIBS=
+    ;;
  win32)
     AC_DEFINE(GC_WIN32_THREADS,1)
     dnl Old wine getenv may not return NULL for missing entry.
--- gcc-4.0.0.orig/boehm-gc/os_dep.c	13 Aug 2004 23:05:30 -0000	1.30
+++ gcc-4.0.0/boehm-gc/os_dep.c	22 Apr 2005 18:11:30 -0000	1.30.34.1
@@ -945,8 +945,17 @@
 	  } /* Otherwise it's not safe to add 16 bytes and we fall	*/
 	    /* back to using /proc.					*/
 #	else 
+#	ifdef SPARC
+	  /* Older versions of glibc for 64-bit Sparc do not set
+	   * this variable correctly, it gets set to either zero
+	   * or one.
+	   */
+	  if (__libc_stack_end != (ptr_t) (unsigned long)0x1)
+	    return __libc_stack_end;
+#	else
 	  return __libc_stack_end;
 #	endif
+#	endif
       }
     f = open("/proc/self/stat", O_RDONLY);
     if (f < 0 || STAT_READ(f, stat_buf, STAT_BUF_SIZE) < 2 * STAT_SKIP) {
--- gcc-4.0.0.orig/boehm-gc/include/private/gcconfig.h	12 Apr 2005 19:48:42 -0000	1.39.18.1
+++ gcc-4.0.0/boehm-gc/include/private/gcconfig.h	22 Apr 2005 18:11:31 -0000	1.39.18.2
@@ -918,12 +918,10 @@
       extern ptr_t GC_SysVGetDataStart();
 #     ifdef __arch64__
 #	define DATASTART GC_SysVGetDataStart(0x100000, _etext)
-	/* libc_stack_end is not set reliably for sparc64 */
-#       define STACKBOTTOM ((ptr_t) 0x80000000000ULL)
 #     else
 #       define DATASTART GC_SysVGetDataStart(0x10000, _etext)
-#	define LINUX_STACKBOTTOM
 #     endif
+#     define LINUX_STACKBOTTOM
 #   endif
 #   ifdef OPENBSD
 #     define OS_TYPE "OPENBSD"
--- gcc-4.0.0.orig/fixincludes/ChangeLog	21 Apr 2005 05:17:31 -0000	1.32.2.3
+++ gcc-4.0.0/fixincludes/ChangeLog	24 Apr 2005 22:52:45 -0000	1.32.2.4
@@ -1,3 +1,17 @@
+2005-04-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
+
+	* configure.ac (fixincludes_UNLOCKED_FUNCS): New.
+	(AC_CHECK_FUNCS, AC_CHECK_DECLS): Check for fixincludes_UNLOCKED_FUNCS.
+	* system.h (putchar, getc, getchar, clearerr, feof, fileno,
+	fflush, fgetc, fgets, ferror, fread): Redefine to the associated
+	_unlocked function.
+	(fwrite_unlocked): Fix prototype.
+	
+	* configure, config.in: Regenerate.
+
+	* system.h (fopen, fdopen, freopen): Define these to the unlocked
+	libiberty functions.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/fixincludes/config.h.in	15 Oct 2004 07:58:38 -0000	1.2
+++ gcc-4.0.0/fixincludes/config.h.in	24 Apr 2005 22:52:46 -0000	1.2.22.1
@@ -3,14 +3,45 @@
 /* Defined to the executable file extension on the host system */
 #undef EXE_EXT
 
+/* Define to 1 if you have the `clearerr_unlocked' function. */
+#undef HAVE_CLEARERR_UNLOCKED
+
 /* Define to 1 if you have the declaration of `abort', and to 0 if you don't.
    */
 #undef HAVE_DECL_ABORT
 
+/* Define to 1 if you have the declaration of `clearerr_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_CLEARERR_UNLOCKED
+
 /* Define to 1 if you have the declaration of `errno', and to 0 if you don't.
    */
 #undef HAVE_DECL_ERRNO
 
+/* Define to 1 if you have the declaration of `feof_unlocked', and to 0 if you
+   don't. */
+#undef HAVE_DECL_FEOF_UNLOCKED
+
+/* Define to 1 if you have the declaration of `ferror_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FERROR_UNLOCKED
+
+/* Define to 1 if you have the declaration of `fflush_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FFLUSH_UNLOCKED
+
+/* Define to 1 if you have the declaration of `fgetc_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FGETC_UNLOCKED
+
+/* Define to 1 if you have the declaration of `fgets_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FGETS_UNLOCKED
+
+/* Define to 1 if you have the declaration of `fileno_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FILENO_UNLOCKED
+
 /* Define to 1 if you have the declaration of `fprintf_unlocked', and to 0 if
    you don't. */
 #undef HAVE_DECL_FPRINTF_UNLOCKED
@@ -23,10 +54,26 @@
    you don't. */
 #undef HAVE_DECL_FPUTS_UNLOCKED
 
+/* Define to 1 if you have the declaration of `fread_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_FREAD_UNLOCKED
+
 /* Define to 1 if you have the declaration of `fwrite_unlocked', and to 0 if
    you don't. */
 #undef HAVE_DECL_FWRITE_UNLOCKED
 
+/* Define to 1 if you have the declaration of `getchar_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_GETCHAR_UNLOCKED
+
+/* Define to 1 if you have the declaration of `getc_unlocked', and to 0 if you
+   don't. */
+#undef HAVE_DECL_GETC_UNLOCKED
+
+/* Define to 1 if you have the declaration of `putchar_unlocked', and to 0 if
+   you don't. */
+#undef HAVE_DECL_PUTCHAR_UNLOCKED
+
 /* Define to 1 if you have the declaration of `putc_unlocked', and to 0 if you
    don't. */
 #undef HAVE_DECL_PUTC_UNLOCKED
@@ -34,6 +81,24 @@
 /* Define to 1 if you have the <fcntl.h> header file. */
 #undef HAVE_FCNTL_H
 
+/* Define to 1 if you have the `feof_unlocked' function. */
+#undef HAVE_FEOF_UNLOCKED
+
+/* Define to 1 if you have the `ferror_unlocked' function. */
+#undef HAVE_FERROR_UNLOCKED
+
+/* Define to 1 if you have the `fflush_unlocked' function. */
+#undef HAVE_FFLUSH_UNLOCKED
+
+/* Define to 1 if you have the `fgetc_unlocked' function. */
+#undef HAVE_FGETC_UNLOCKED
+
+/* Define to 1 if you have the `fgets_unlocked' function. */
+#undef HAVE_FGETS_UNLOCKED
+
+/* Define to 1 if you have the `fileno_unlocked' function. */
+#undef HAVE_FILENO_UNLOCKED
+
 /* Define to 1 if you have the `fprintf_unlocked' function. */
 #undef HAVE_FPRINTF_UNLOCKED
 
@@ -43,9 +108,18 @@
 /* Define to 1 if you have the `fputs_unlocked' function. */
 #undef HAVE_FPUTS_UNLOCKED
 
+/* Define to 1 if you have the `fread_unlocked' function. */
+#undef HAVE_FREAD_UNLOCKED
+
 /* Define to 1 if you have the `fwrite_unlocked' function. */
 #undef HAVE_FWRITE_UNLOCKED
 
+/* Define to 1 if you have the `getchar_unlocked' function. */
+#undef HAVE_GETCHAR_UNLOCKED
+
+/* Define to 1 if you have the `getc_unlocked' function. */
+#undef HAVE_GETC_UNLOCKED
+
 /* Define to 1 if you have the <inttypes.h> header file. */
 #undef HAVE_INTTYPES_H
 
@@ -61,6 +135,9 @@
 /* Define if read-only mmap of a plain file works. */
 #undef HAVE_MMAP_FILE
 
+/* Define to 1 if you have the `putchar_unlocked' function. */
+#undef HAVE_PUTCHAR_UNLOCKED
+
 /* Define to 1 if you have the `putc_unlocked' function. */
 #undef HAVE_PUTC_UNLOCKED
 
--- gcc-4.0.0.orig/fixincludes/configure.ac	2 Dec 2004 11:03:21 -0000	1.5
+++ gcc-4.0.0/fixincludes/configure.ac	24 Apr 2005 22:52:46 -0000	1.5.12.1
@@ -68,10 +68,13 @@
 AC_HEADER_STDC
 AC_CHECK_HEADERS([stddef.h stdlib.h strings.h unistd.h fcntl.h sys/file.h \
 	sys/stat.h])
-AC_CHECK_FUNCS(putc_unlocked fputc_unlocked fputs_unlocked \
-        fwrite_unlocked fprintf_unlocked)
-AC_CHECK_DECLS([abort, errno, putc_unlocked, fputc_unlocked,
-        fputs_unlocked, fwrite_unlocked, fprintf_unlocked])
+define(fixincludes_UNLOCKED_FUNCS, clearerr_unlocked feof_unlocked dnl
+  ferror_unlocked fflush_unlocked fgetc_unlocked fgets_unlocked dnl
+  fileno_unlocked fprintf_unlocked fputc_unlocked fputs_unlocked dnl
+  fread_unlocked fwrite_unlocked getchar_unlocked getc_unlocked dnl
+  putchar_unlocked putc_unlocked)
+AC_CHECK_FUNCS(fixincludes_UNLOCKED_FUNCS)
+AC_CHECK_DECLS(m4_split(m4_normalize(abort errno fixincludes_UNLOCKED_FUNCS)))
 
 # Checks for typedefs, structures, and compiler characteristics.
 AC_C_CONST
--- gcc-4.0.0.orig/fixincludes/system.h	31 Aug 2004 09:26:05 -0000	1.1
+++ gcc-4.0.0/fixincludes/system.h	24 Apr 2005 22:52:46 -0000	1.1.48.1
@@ -38,6 +38,11 @@
 #define NULL 0
 #endif
 
+/* Use the unlocked open routines from libiberty.  */
+#define fopen(PATH,MODE) fopen_unlocked(PATH,MODE)
+#define fdopen(FILDES,MODE) fdopen_unlocked(FILDES,MODE)
+#define freopen(PATH,MODE,STREAM) freopen_unlocked(PATH,MODE,STREAM)
+
 /* fixincludes is not a multi-threaded application and therefore we
    do not have to use the locking functions.  In fact, using the locking
    functions can cause the compiler to be significantly slower under
@@ -57,11 +62,65 @@
 #  undef putc
 #  define putc(C, Stream) putc_unlocked (C, Stream)
 # endif
+# ifdef HAVE_PUTCHAR_UNLOCKED
+#  undef putchar
+#  define putchar(C) putchar_unlocked (C)
+# endif
+# ifdef HAVE_GETC_UNLOCKED
+#  undef getc
+#  define getc(Stream) getc_unlocked (Stream)
+# endif
+# ifdef HAVE_GETCHAR_UNLOCKED
+#  undef getchar
+#  define getchar() getchar_unlocked ()
+# endif
 # ifdef HAVE_FPUTC_UNLOCKED
 #  undef fputc
 #  define fputc(C, Stream) fputc_unlocked (C, Stream)
 # endif
 
+# ifdef HAVE_CLEARERR_UNLOCKED
+#  undef clearerr
+#  define clearerr(Stream) clearerr_unlocked (Stream)
+#  if defined (HAVE_DECL_CLEARERR_UNLOCKED) && !HAVE_DECL_CLEARERR_UNLOCKED
+extern void clearerr_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FEOF_UNLOCKED
+#  undef feof
+#  define feof(Stream) feof_unlocked (Stream)
+#  if defined (HAVE_DECL_FEOF_UNLOCKED) && !HAVE_DECL_FEOF_UNLOCKED
+extern int feof_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FILENO_UNLOCKED
+#  undef fileno
+#  define fileno(Stream) fileno_unlocked (Stream)
+#  if defined (HAVE_DECL_FILENO_UNLOCKED) && !HAVE_DECL_FILENO_UNLOCKED
+extern int fileno_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FFLUSH_UNLOCKED
+#  undef fflush
+#  define fflush(Stream) fflush_unlocked (Stream)
+#  if defined (HAVE_DECL_FFLUSH_UNLOCKED) && !HAVE_DECL_FFLUSH_UNLOCKED
+extern int fflush_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FGETC_UNLOCKED
+#  undef fgetc
+#  define fgetc(Stream) fgetc_unlocked (Stream)
+#  if defined (HAVE_DECL_FGETC_UNLOCKED) && !HAVE_DECL_FGETC_UNLOCKED
+extern int fgetc_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FGETS_UNLOCKED
+#  undef fgets
+#  define fgets(S, n, Stream) fgets_unlocked (S, n, Stream)
+#  if defined (HAVE_DECL_FGETS_UNLOCKED) && !HAVE_DECL_FGETS_UNLOCKED
+extern char *fgets_unlocked (char *, int, FILE *);
+#  endif
+# endif
 # ifdef HAVE_FPUTS_UNLOCKED
 #  undef fputs
 #  define fputs(String, Stream) fputs_unlocked (String, Stream)
@@ -69,11 +128,25 @@
 extern int fputs_unlocked (const char *, FILE *);
 #  endif
 # endif
+# ifdef HAVE_FERROR_UNLOCKED
+#  undef ferror
+#  define ferror(Stream) ferror_unlocked (Stream)
+#  if defined (HAVE_DECL_FERROR_UNLOCKED) && !HAVE_DECL_FERROR_UNLOCKED
+extern int ferror_unlocked (FILE *);
+#  endif
+# endif
+# ifdef HAVE_FREAD_UNLOCKED
+#  undef fread
+#  define fread(Ptr, Size, N, Stream) fread_unlocked (Ptr, Size, N, Stream)
+#  if defined (HAVE_DECL_FREAD_UNLOCKED) && !HAVE_DECL_FREAD_UNLOCKED
+extern size_t fread_unlocked (void *, size_t, size_t, FILE *);
+#  endif
+# endif
 # ifdef HAVE_FWRITE_UNLOCKED
 #  undef fwrite
 #  define fwrite(Ptr, Size, N, Stream) fwrite_unlocked (Ptr, Size, N, Stream)
 #  if defined (HAVE_DECL_FWRITE_UNLOCKED) && !HAVE_DECL_FWRITE_UNLOCKED
-extern int fwrite_unlocked (const void *, size_t, size_t, FILE *);
+extern size_t fwrite_unlocked (const void *, size_t, size_t, FILE *);
 #  endif
 # endif
 # ifdef HAVE_FPRINTF_UNLOCKED
--- gcc-4.0.0.orig/gcc/ChangeLog	21 Apr 2005 05:17:52 -0000	2.7592.2.172
+++ gcc-4.0.0/gcc/ChangeLog	1 May 2005 19:24:50 -0000	2.7592.2.210
@@ -1,3 +1,302 @@
+2005-05-01  Gerald Pfeifer  <gerald@pfeifer.com>
+
+	* doc/install.texi (Specific): Omit dots in the @anchors names
+	for i?86-*-sco3.2v5*, i?86-*-solaris2.10, and sparc-sun-solaris2.7.
+	Omit underscores for x86_64-*-* and the "all ELF targets" entry.
+
+2005-05-01  Eric Botcazou  <ebotcazou@libertysurf.fr>
+
+	PR bootstrap/20633
+	* config/freebsd-spec.h (FBSD_CPP_SPEC): Add %(cpp_arch).
+
+2005-05-01  Michael Matz  <matz@suse.de>
+
+	PR c++/19542
+	* c-common.c (c_common_nodes_and_builtins): Create global null_node.
+	(warn_strict_null_sentinel): Define.
+	(check_function_sentinel): Check for null_node as valid sentinel too.
+	* c-common.h (c_tree_index): Added CTI_NULL.
+	(null_node) Define global_tree[CTI_NULL].
+	(warn_strict_null_sentinel): Declare.
+	* c-opts.c: (c_common_handle_option): Handle -Wstrict-null-sentinel.
+	* c.opt: (Wstrict-null-sentinel): New C++ option.
+	* doc/invoke.texi (C++ Options): Document -Wstrict-null-sentinel.
+
+2005-04-30  Paul Brook  <paul@codesourcery.com>
+
+	* config/arm/bpabi.h (RENAME_LIBRARY_SET): Always use .thumb_set in
+	thumb mode.
+	* config/arm/ieee754-df.S: Use __INTERWORKING_STUBS__.
+	* config/arm/ieee754-sf.S: Ditto.
+	* config/arm/lib1funcs.asm: Define and use __INTERWORKING_STUBS__.
+	(FUNC_ALIAS): Use .thumb_set for thumb routines.
+
+2005-04-29  Michael Matz  <matz@suse.de>
+
+	* config/i386/i386.md (movmemsi): Also active when
+	TARGET_INLINE_ALL_STRINGOPS.
+
+2005-04-29  Michael Matz  <matz@suse.de>
+
+	PR rtl-optimization/21144
+	* postreload.c (reload_cse_move2add): Check for VOIDmode.
+
+2005-04-29  Alan Modra  <amodra@bigpond.net.au>
+
+	PR target/21098
+	* config/rs6000/rs6000.c (rs6000_elf_end_indicate_exec_stack): New.
+	* config/rs6000/linux64.h (TARGET_ASM_FILE_END): Use the above.
+
+2005-04-28  James E Wilson  <wilson@specifixinc.com>
+
+	* doc/install.texi: Update -enable-languages info.  Correct path to
+	html docs.
+
+2005-04-19  Andrew Haley  <aph@redhat.com>
+	
+	PR java/21022
+	* dbxout.c (dbxout_type_fields): Check DECL_IGNORED_P before
+	looking at a field's bitpos.
+
+2005-04-28  Kazu Hirata  <kazu@cs.umass.edu>
+
+	* config.gcc: Obsolete c4x-* and tic4x-*.
+
+2005-04-28  Joseph S. Myers  <joseph@codesourcery.com>
+
+	* c-typeck.c (build_compound_expr): Correct logic in last change.
+
+2005-04-27  Joseph S. Myers  <joseph@codesourcery.com>
+
+	PR c/21159
+	* c-typeck.c (build_compound_expr): Don't warn for left-hand side
+	being a compound expression whose right-hand side is cast to void.
+
+2005-04-27  Joseph S. Myers  <joseph@codesourcery.com>
+
+	PR c/21213
+	* c-decl.c (finish_struct): Don't dereference NULL TYPE_FIELDS of
+	transparent union.
+
+2005-04-27  Joseph S. Myers  <joseph@codesourcery.com>
+
+	PR c/20740
+	* c-format.c (init_dynamic_asm_fprintf_info): Give errors, not
+	assertion failures, if __gcc_host_wide_int__ is not properly
+	defined.
+	(init_dynamic_diag_info): Give errors, not assertion failures, if
+	location_t, tree or __gcc_host_wide_int__ are not properly
+	defined.
+
+2005-04-25  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
+
+	* collect2.c, gcc.c, gcov-dump.c, gcov.c, gen-protos.c,
+	gensupport.c, protoize.c, toplev.c: Replace calls to
+	`unlock_stream' with `unlock_std_streams'.
+
+2005-04-25  Joseph S. Myers  <joseph@codesourcery.com>
+
+	* doc/invoke.texi (Blackfin Options): Avoid empty @opindex line.
+
+2005-04-25  Joseph S. Myers  <joseph@codesourcery.com>
+
+	PR bootstrap/21215
+	* doc/install.texi: Document correct assembler and linker to use
+	on i?86-*-solaris2.10.
+
+2005-04-25  Daniel Berlin  <dberlin@dberlin.org>
+
+	Fix PR tree-optimization/21173
+	
+	* tree-ssa-pre.c (create_expression_by_pieces): Call unshare_expr
+	on things we pass to force_gimple_operand.  Don't try to special
+	case min_invariants.
+
+2005-04-25  Bernd Schmidt  <bernd.schmidt@analog.com>
+
+	* config/bfin/bfin-modes.def: New file.
+	* config/bfin/bfin-protos.h: New file.
+	* config/bfin/bfin.c: New file.
+	* config/bfin/bfin.h: New file.
+	* config/bfin/bfin.md: New file.
+	* config/bfin/crti.s: New file.
+	* config/bfin/crtn.s: New file.
+	* config/bfin/elf.h: New file.
+	* config/bfin/lib1funcs.asm: New file.
+	* config/bfin/predicates.md: New file.
+	* config/bfin/t-bfin: New file.
+	* config/bfin/t-bfin-elf: New file.
+	* doc/extend.texi (exception_handler, kspisusp, nesting, nmi_handler):
+	Document new attributes.
+	(interrupt, interrupt_handler, saveall): Update documentation for
+	these attributes.
+	* doc/install.texi (Specific): Add entry for the Blackfin.
+	* doc/invoke.texi (Blackfin Options): New section.
+	* doc/md.texi (Blackfin family): New section to document constraints.
+	* config.gcc: Add bfin*-* and bfin*-elf configurations.
+
+2005-04-25  Ralf Corsepius  <ralf.corsepius@rtems.org>
+
+	* config.gcc (avr-*-*): Remove redundant "case".
+
+2005-04-25  Ralf Corsepius  <ralf.corsepius@rtems.org>
+
+	PR target/17822
+	* config/avr/t-avr (AR_FOR_TARGET,RANLIB_FOR_TARGET): Remove.
+
+2005-04-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
+
+	PR/17092
+	* configure.ac (gcc_UNLOCKED_FUNCS): New.
+	(AC_CHECK_FUNCS, AC_CHECK_DECLS): Check for gcc_UNLOCKED_FUNCS.
+	* system.h (putchar, getc, getchar, clearerr, feof, fileno,
+	fflush, fgetc, fgets, ferror, fread): Redefine to the associated
+	_unlocked function.
+	(fwrite_unlocked): Fix prototype.
+	
+	* configure, config.in: Regenerate.
+
+	* system.h (fopen, fdopen, freopen): Define these to the unlocked
+	libiberty functions.
+
+	* collect2.c (main): Unlock the stdio streams.
+	* gcc.c (main): Likewise.
+	* gcov-dump.c (main): Likewise.
+	* gcov.c (main): Likewise.
+	* gen-protos.c (main): Likewise.
+	* gensupport.c (init_md_reader_args_cb): Likewise.
+	* protoize.c (main): Likewise.
+	* toplev.c (general_init): Likewise.
+
+2005-04-24  Richard Henderson  <rth@redhat.com>
+
+	PR rtl-opt/21163
+	* simplify-rtx.c (simplify_binary_operation) <IOR>: Check
+	for SCALAR_INT_MODE_P instead of not MODE_CC before returning
+	constm1_rtx.
+	<XOR, AND, LSHIFTRT, UMIN>: Use CONST0_RTX.
+	<UDIV, UMOD>: Use CONST0_RTX and CONST1_RTX.
+	<DIV, MOD>: Likewise.
+
+2005-04-24  Jakub Jelinek  <jakub@redhat.com>
+
+	PR middle-end/20991
+	* cgraph.h (cgraph_local_info): Add vtable_method field.
+	* varasm.c (mark_decl_referenced): If cgraph_global_info_ready
+	and node is vtable_method, finalized and not reachable, don't do
+	anything.
+
+	Revert:
+	2005-04-18  Jakub Jelinek  <jakub@redhat.com>
+	* tree-ssa-ccp.c (fold_stmt): Don't optimize OBJ_TYPE_REFs if that
+	would result in an already finalized unreachable node becoming
+	reachable while cgraph_global_info_ready.
+
+2005-04-24  Ralf Corsepius  <ralf.corsepius@rtems.org>
+
+	PR target/17824
+	* config/c4x/c4x.h (ASM_PROG, LD_PROG): Remove.
+
+2005-04-24  Richard Henderson  <rth@redhat.com>
+
+        PR target/21101
+	* config/i386/i386.h (CANNOT_CHANGE_MODE_CLASS): Move guts to ...
+	* config/i386/i386.c (ix86_cannot_change_mode_class): ... here.
+	Deny modes smaller than 4 bytes.
+	* config/i386/i386-protos.h: Update.
+
+2005-04-24  Ralf Corsepius  <ralf.corsepius@rtems.org>
+
+	* config.gcc (h8300-*-rtems*): Add h8300-*-rtemscoff*.
+	Switch h8300-*-rtems* to ELF.
+
+2005-04-23  Richard Henderson  <rth@redhat.com>
+
+	* simplify-rtx.c (simplify_binary_operation): Fix second instance
+	later in the same function.
+
+	PR rtl-opt/21102
+	* simplify-rtx.c (simplify_binary_operation): Fix mode check before
+	performing some integral scalar simplifications.
+
+2005-04-23  Richard Henderson  <rth@redhat.com>
+
+	PR target/21100
+	* config/i386/mmx.md (push<MMXMODE>1): Fix predicate thinko.
+
+2005-04-23  Richard Henderson  <rth@redhat.com>
+
+	PR target/21099
+	* config/i386/i386.c (ix86_split_to_parts): Use proper mode when
+	simplifying CONST_VECTOR.
+
+2005-04-22  James E Wilson  <wilson@specifixinc.com>
+
+	PR c++/20805
+	* dwarf2out.c (gen_variable_die): Don't emit a specification if this
+	is another declaration.
+
+2005-04-22  Michael Matz  <matz@suse.de>
+
+	PR middle-end/20973
+	* reload.c (push_reload, find_dummy_reload): Check for uninitialized
+	pseudos.
+
+2005-04-22  David Edelsohn  <edelsohn@gnu.org>
+
+	Backport from mainline.
+	* config/rs6000/rs6000.c (rs6000_init_libfuncs): Set TFmode
+	optabs to xlq names if TARGET_XL_COMPAT.
+
+2005-04-22  Joseph S. Myers  <joseph@codesourcery.com>
+
+	PR c/12913
+	* c-tree.h (struct c_label_list): Update comment.
+	(struct c_label_context): Rename to struct c_label_context_se.
+	(label_context_stack): Rename to label_context_stack_se.
+	(C_DECL_UNJUMPABLE_VM, C_DECL_UNDEFINABLE_VM, struct
+	c_label_context_vm, label_context_stack_vm, c_begin_vm_scope,
+	c_end_vm_scope): New.
+	(C_DECL_DECLARED_BUILTIN, C_DECL_USED): Use FUNCTION_DECL_CHECK.
+	* c-decl.c (pop_scope): Call c_end_vm_scope.
+	(pushdecl): Call c_begin_vm_scope for variably modified
+	declarations.
+	(define_label): Check for jumping into scope of identifier with
+	variably modified type.  Push label on stack for those defined at
+	current context of identifiers with variably modified type.
+	(start_function): Create stack level for context of identifiers
+	with variably modified type.
+	(finish_function): Pop stack level for context of identifiers with
+	variably modified type.
+	* c-typeck.c (label_context_stack): Rename to
+	label_context_stack_se.
+	(label_context_stack_vm, c_begin_vm_scope, c_end_vm_scope): New.
+	(c_finish_goto_label): Check for jumping into scope of identifier
+	with variably modified type.  Push label on stack for those jumped
+	to from current context of identifiers with variably modified
+	type.
+	(struct c_switch): Add blocked_vm.
+	(c_start_case): Initialize blocked_vm.
+	(do_case): Check blocked_vm.
+	(c_finish_case): Add comment.
+	(c_begin_stmt_expr, c_finish_stmt_expr): Update for renamed
+	variable label_context_stack.
+
+2005-04-22  Joseph S. Myers  <joseph@codesourcery.com>
+
+	* varasm.c (do_assemble_alias): Return early if TREE_ASM_WRITTEN
+	(decl).
+
+2005-04-22  Eric Botcazou  <ebotcazou@libertysurf.fr>
+
+	* doc/invoke.texi (SPARC options): Document that -mapp-regs
+	is turned off by default on Solaris.
+
+2005-04-21  Mark Mitchell  <mark@codesourcery.com>
+
+	* version.c (version_string): Restore prerelease information.
+	* doc/include/gcc-common.texi (version): Set to 4.0.1.
+
 2005-04-20  Release Manager
 
 	* GCC 4.0.0 released.
--- gcc-4.0.0.orig/gcc/c-common.c	30 Mar 2005 01:38:04 -0000	1.606.2.2
+++ gcc-4.0.0/gcc/c-common.c	1 May 2005 01:11:57 -0000	1.606.2.3
@@ -284,6 +284,12 @@
 
 int warn_format;
 
+/* Warn about using __null (as NULL in C++) as sentinel.  For code compiled
+   with GCC this doesn't matter as __null is guaranteed to have the right
+   size.  */
+
+int warn_strict_null_sentinel;
+
 /* Zero means that faster, ...NonNil variants of objc_msgSend...
    calls will be used in ObjC; passing nil receivers to such calls
    will most likely result in crashes.  */
@@ -3269,6 +3275,11 @@
     mudflap_init ();
 
   main_identifier_node = get_identifier ("main");
+
+  /* Create the built-in __null node.  It is important that this is
+     not shared.  */
+  null_node = make_node (INTEGER_CST);
+  TREE_TYPE (null_node) = c_common_type_for_size (POINTER_SIZE, 0);
 }
 
 /* Look up the function in built_in_decls that corresponds to DECL
@@ -5115,8 +5126,15 @@
 	    }
 
 	  /* Validate the sentinel.  */
-	  if (!POINTER_TYPE_P (TREE_TYPE (TREE_VALUE (sentinel)))
-	      || !integer_zerop (TREE_VALUE (sentinel)))
+	  if ((!POINTER_TYPE_P (TREE_TYPE (TREE_VALUE (sentinel)))
+	       || !integer_zerop (TREE_VALUE (sentinel)))
+	      /* Although __null (in C++) is only an integer we allow it
+		 nevertheless, as we are guaranteed that it's exactly
+		 as wide as a pointer, and we don't want to force
+		 users to cast the NULL they have written there.
+		 We warn with -Wstrict-null-sentinel, though.  */
+              && (warn_strict_null_sentinel
+		  || null_node != TREE_VALUE (sentinel)))
 	    warning ("missing sentinel in function call");
 	}
     }
--- gcc-4.0.0.orig/gcc/c-common.h	30 Mar 2005 01:38:07 -0000	1.277.2.1
+++ gcc-4.0.0/gcc/c-common.h	1 May 2005 01:11:55 -0000	1.277.2.2
@@ -160,6 +160,8 @@
     
     CTI_VOID_ZERO,
 
+    CTI_NULL,
+
     CTI_MAX
 };
 
@@ -204,6 +206,9 @@
 /* A node for `((void) 0)'.  */
 #define void_zero_node                  c_global_trees[CTI_VOID_ZERO]
 
+/* The node for C++ `__null'.  */
+#define null_node                       c_global_trees[CTI_NULL]
+
 extern GTY(()) tree c_global_trees[CTI_MAX];
 
 /* In a RECORD_TYPE, a sorted array of the fields of the type, not a
@@ -575,6 +580,12 @@
 
 extern int warn_implicit;
 
+/* Warn about using __null (as NULL in C++) as sentinel.  For code compiled
+   with GCC this doesn't matter as __null is guaranteed to have the right
+   size.  */
+
+extern int warn_strict_null_sentinel;
+
 /* Maximum template instantiation depth.  This limit is rather
    arbitrary, but it exists to limit the time it takes to notice
    infinite template instantiations.  */
--- gcc-4.0.0.orig/gcc/c-decl.c	6 Apr 2005 17:21:35 -0000	1.630.6.6
+++ gcc-4.0.0/gcc/c-decl.c	27 Apr 2005 00:49:29 -0000	1.630.6.8
@@ -673,6 +673,8 @@
   bool functionbody = scope->function_body;
   bool keep = functionbody || scope->keep || scope->bindings;
 
+  c_end_vm_scope (scope->depth);
+
   /* If appropriate, create a BLOCK to record the decls for the life
      of this function.  */
   block = 0;
@@ -1982,6 +1984,12 @@
 	  || DECL_INITIAL (x) || !DECL_EXTERNAL (x)))
     DECL_CONTEXT (x) = current_function_decl;
 
+  /* If this is of variably modified type, prevent jumping into its
+     scope.  */
+  if ((TREE_CODE (x) == VAR_DECL || TREE_CODE (x) == TYPE_DECL)
+      && variably_modified_type_p (TREE_TYPE (x), NULL_TREE))
+    c_begin_vm_scope (scope->depth);
+
   /* Anonymous decls are just inserted in the scope.  */
   if (!name)
     {
@@ -2439,7 +2447,7 @@
      if there is a containing function with a declared label with
      the same name.  */
   tree label = I_LABEL_DECL (name);
-  struct c_label_list *nlist;
+  struct c_label_list *nlist_se, *nlist_vm;
 
   if (label
       && ((DECL_CONTEXT (label) == current_function_decl
@@ -2458,6 +2466,9 @@
 	 definition.  */
       if (C_DECL_UNDEFINABLE_STMT_EXPR (label))
 	error ("%Jjump into statement expression", label);
+      if (C_DECL_UNDEFINABLE_VM (label))
+	error ("%Jjump into scope of identifier with variably modified type",
+	       label);
       DECL_SOURCE_LOCATION (label) = location;
     }
   else
@@ -2475,10 +2486,15 @@
              "identifier %qs conflicts", &location,
 	     IDENTIFIER_POINTER (name));
 
-  nlist = XOBNEW (&parser_obstack, struct c_label_list);
-  nlist->next = label_context_stack->labels_def;
-  nlist->label = label;
-  label_context_stack->labels_def = nlist;
+  nlist_se = XOBNEW (&parser_obstack, struct c_label_list);
+  nlist_se->next = label_context_stack_se->labels_def;
+  nlist_se->label = label;
+  label_context_stack_se->labels_def = nlist_se;
+
+  nlist_vm = XOBNEW (&parser_obstack, struct c_label_list);
+  nlist_vm->next = label_context_stack_vm->labels_def;
+  nlist_vm->label = label;
+  label_context_stack_vm->labels_def = nlist_vm;
 
   /* Mark label as having been defined.  */
   DECL_INITIAL (label) = error_mark_node;
@@ -5327,7 +5343,7 @@
      make it one, warn and turn off the flag.  */
   if (TREE_CODE (t) == UNION_TYPE
       && TYPE_TRANSPARENT_UNION (t)
-      && TYPE_MODE (t) != DECL_MODE (TYPE_FIELDS (t)))
+      && (!TYPE_FIELDS (t) || TYPE_MODE (t) != DECL_MODE (TYPE_FIELDS (t))))
     {
       TYPE_TRANSPARENT_UNION (t) = 0;
       warning ("union cannot be made transparent");
@@ -5655,7 +5671,8 @@
 {
   tree decl1, old_decl;
   tree restype, resdecl;
-  struct c_label_context *nstack;
+  struct c_label_context_se *nstack_se;
+  struct c_label_context_vm *nstack_vm;
 
   current_function_returns_value = 0;  /* Assume, until we see it does.  */
   current_function_returns_null = 0;
@@ -5664,11 +5681,18 @@
   current_extern_inline = 0;
   c_switch_stack = NULL;
 
-  nstack = XOBNEW (&parser_obstack, struct c_label_context);
-  nstack->labels_def = NULL;
-  nstack->labels_used = NULL;
-  nstack->next = label_context_stack;
-  label_context_stack = nstack;
+  nstack_se = XOBNEW (&parser_obstack, struct c_label_context_se);
+  nstack_se->labels_def = NULL;
+  nstack_se->labels_used = NULL;
+  nstack_se->next = label_context_stack_se;
+  label_context_stack_se = nstack_se;
+
+  nstack_vm = XOBNEW (&parser_obstack, struct c_label_context_vm);
+  nstack_vm->labels_def = NULL;
+  nstack_vm->labels_used = NULL;
+  nstack_vm->scope = 0;
+  nstack_vm->next = label_context_stack_vm;
+  label_context_stack_vm = nstack_vm;
 
   /* Indicate no valid break/continue context by setting these variables
      to some non-null, non-label value.  We'll notice and emit the proper
@@ -6251,7 +6275,8 @@
 {
   tree fndecl = current_function_decl;
 
-  label_context_stack = label_context_stack->next;
+  label_context_stack_se = label_context_stack_se->next;
+  label_context_stack_vm = label_context_stack_vm->next;
 
   if (TREE_CODE (fndecl) == FUNCTION_DECL
       && targetm.calls.promote_prototypes (TREE_TYPE (fndecl)))
